Package ghidra.program.database.function

# Class VariableDB

java.lang.Object
ghidra.program.database.function.VariableDB

All Implemented Interfaces:
  `Variable`, `Comparable<Variable>`

Direct Known Subclasses:
  `LocalVariableDB`, `ReturnParameterDB`

public abstract class VariableDB extends Object implements Variable
Database implementation of a Variable.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected FunctionDB`
  `function`
  `protected FunctionManagerDB`
  `functionMgr`
  `protected VariableStorage`
  `storage`
  `protected VariableSymbolDB`
  `symbol`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `compareTo(Variable otherVar)`
  `boolean`
  `equals(Object obj)`
  `String`
  `getComment()`
  Get the Comment for this variable
  `DataType`
  `getDataType()`
  Get the Data Type of this variable
  `Varnode`
  `getFirstStorageVarnode()`
  Get the first storage varnode for this variable
  `Function`
  `getFunction()`
  Returns the function that contains this Variable.
  `Varnode`
  `getLastStorageVarnode()`
  Get the last storage varnode for this variable
  `int`
  `getLength()`
  Get the length of this variable
  `Address`
  `getMinAddress()`
  `String`
  `getName()`
  Get the Name of this variable or null if not assigned or not-applicable
  `Program`
  `getProgram()`
  Returns the program that contains this variable or is the intended target
  `Register`
  `getRegister()`
  `List<Register>`
  `getRegisters()`
  `SourceType`
  `getSource()`
  Get the source of this variable
  `int`
  `getStackOffset()`
  `Symbol`
  `getSymbol()`
  `VariableStorage`
  `getVariableStorage()`
  Get the variable storage associated with this variable.
  `boolean`
  `hasAssignedStorage()`
  `int`
  `hashCode()`
  `boolean`
  `hasStackStorage()`
  `boolean`
  `isCompoundVariable()`
  `boolean`
  `isEquivalent(Variable otherVar)`
  Determine is another variable is equivalent to this variable.
  `boolean`
  `isMemoryVariable()`
  `boolean`
  `isRegisterVariable()`
  `boolean`
  `isStackVariable()`
  `boolean`
  `isUniqueVariable()`
  `final boolean`
  `isValid()`
  Verify that the variable is valid (i.e., storage is valid and size matches variable data type size)
  `protected boolean`
  `isVoidAllowed()`
  `void`
  `setComment(String comment)`
  Set the comment for this variable
  `void`
  `setDataType(DataType type, boolean alignStack, boolean force, SourceType source)`
  Set the Data Type of this variable.
  `void`
  `setDataType(DataType type, VariableStorage newStorage, boolean force, SourceType source)`
  Set the Data Type of this variable and the associated storage whose size matches the data type length.
  `void`
  `setDataType(DataType type, SourceType source)`
  Set the Data Type of this variable using the default alignment behavior (implementation specific).
  `void`
  `setName(String name, SourceType source)`
  Set the name of this variable.
  `String`
  `toString()`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface ghidra.program.model.listing.Variable

  `getFirstUseOffset`

- ## Field Details

  - ### symbol

    protected VariableSymbolDB symbol

  - ### storage

    protected VariableStorage storage

  - ### function

    protected FunctionDB function

  - ### functionMgr

    protected FunctionManagerDB functionMgr

- ## Method Details

  - ### isVoidAllowed

    protected boolean isVoidAllowed()

  - ### isValid

    public final boolean isValid()
    Description copied from interface: `Variable`
    Verify that the variable is valid (i.e., storage is valid and size matches variable data type size)
    Specified by:
      `isValid` in interface `Variable`
    Returns:
      true if variable is valid

  - ### getProgram

    public Program getProgram()
    Description copied from interface: `Variable`
    Returns the program that contains this variable or is the intended target
    Specified by:
      `getProgram` in interface `Variable`
    Returns:
      the program.

  - ### getDataType

    public DataType getDataType()
    Description copied from interface: `Variable`
    Get the Data Type of this variable
    Specified by:
      `getDataType` in interface `Variable`
    Returns:
      the data type of the variable

  - ### setDataType

    public void setDataType(DataType type, VariableStorage newStorage, boolean force, SourceType source) throws InvalidInputException, VariableSizeException
    Description copied from interface: `Variable`
    Set the Data Type of this variable and the associated storage whose size matches the data type length.

    NOTE: The storage and source are ignored if the function does not have custom storage enabled.

    Specified by:
      `setDataType` in interface `Variable`
    Parameters:
      `type` - the data type
      `newStorage` - properly sized storage for the new data type
      `force` - overwrite conflicting variables
      `source` - variable storage source (used only for function parameters and return)
    Throws:
      `InvalidInputException` - if data type is not a fixed length or violates storage constraints.
      `VariableSizeException` - if force is false and data type size causes a conflict with other variables

  - ### setDataType

    public void setDataType(DataType type, boolean alignStack, boolean force, SourceType source) throws InvalidInputException
    Description copied from interface: `Variable`
    Set the Data Type of this variable. The given dataType must have a fixed length.
    Specified by:
      `setDataType` in interface `Variable`
    Parameters:
      `type` - the data type
      `alignStack` - maintain proper stack alignment/justification if supported by implementation. If false and this is a stack variable, the current stack address/offset will not change. If true, the affect is implementation dependent since alignment can not be performed without access to a compiler specification.
      `force` - overwrite conflicting variables
      `source` - signature source
    Throws:
      `InvalidInputException` - if data type is not a fixed length or violates storage constraints.
      `VariableSizeException` - if force is false and data type size causes a conflict with other variables

  - ### setDataType

    public void setDataType(DataType type, SourceType source) throws InvalidInputException
    Description copied from interface: `Variable`
    Set the Data Type of this variable using the default alignment behavior (implementation specific). The given dataType must have a fixed length. If contained within a stack-frame, data-type size will be constrained by existing variables (e.g., equivalent to force=false) Note: stack offset will be maintained for stack variables.
    Specified by:
      `setDataType` in interface `Variable`
    Parameters:
      `type` - the data type
      `source` - signature source
    Throws:
      `InvalidInputException` - if data type is not a fixed length or violates storage constraints.
      `VariableSizeException` - if data type size causes a conflict with other variables
    See Also:
      - `Variable.setDataType(DataType, boolean, boolean, SourceType)`

  - ### getName

    public String getName()
    Description copied from interface: `Variable`
    Get the Name of this variable or null if not assigned or not-applicable
    Specified by:
      `getName` in interface `Variable`
    Returns:
      the name of the variable

  - ### getLength

    public int getLength()
    Description copied from interface: `Variable`
    Get the length of this variable
    Specified by:
      `getLength` in interface `Variable`
    Returns:
      the length of the variable

  - ### setName

    public void setName(String name, SourceType source) throws DuplicateNameException, InvalidInputException
    Description copied from interface: `Variable`
    Set the name of this variable.
    Specified by:
      `setName` in interface `Variable`
    Parameters:
      `name` - the name
      `source` - the source of this variable name
    Throws:
      `DuplicateNameException` - if the name collides with the name of another variable.
      `InvalidInputException` - if name contains blank characters, is zero length, or is null

  - ### getComment

    public String getComment()
    Description copied from interface: `Variable`
    Get the Comment for this variable
    Specified by:
      `getComment` in interface `Variable`
    Returns:
      the comment

  - ### setComment

    public void setComment(String comment)
    Description copied from interface: `Variable`
    Set the comment for this variable
    Specified by:
      `setComment` in interface `Variable`
    Parameters:
      `comment` - the comment

  - ### getFunction

    public Function getFunction()
    Description copied from interface: `Variable`
    Returns the function that contains this Variable. May be null if the variable is not in a function.
    Specified by:
      `getFunction` in interface `Variable`
    Returns:
      containing function or null

  - ### getSymbol

    public Symbol getSymbol()
    Specified by:
      `getSymbol` in interface `Variable`
    Returns:
      the symbol associated with this variable or null if no symbol associated. Certain dynamic variables such as auto-parameters do not have a symbol and will return null.

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`

  - ### getSource

    public SourceType getSource()
    Description copied from interface: `Variable`
    Get the source of this variable
    Specified by:
      `getSource` in interface `Variable`
    Returns:
      the source of this variable

  - ### hasAssignedStorage

    public boolean hasAssignedStorage()
    Specified by:
      `hasAssignedStorage` in interface `Variable`
    Returns:
      true if this variable has been assigned storage. This is equivalent to `Variable.getVariableStorage()` != null

  - ### getVariableStorage

    public VariableStorage getVariableStorage()
    Description copied from interface: `Variable`
    Get the variable storage associated with this variable.
    Specified by:
      `getVariableStorage` in interface `Variable`
    Returns:
      the variable storage for this variable

  - ### getFirstStorageVarnode

    public Varnode getFirstStorageVarnode()
    Description copied from interface: `Variable`
    Get the first storage varnode for this variable
    Specified by:
      `getFirstStorageVarnode` in interface `Variable`
    Returns:
      the first storage varnode associated with this variable
    See Also:
      - `Variable.getVariableStorage()`

  - ### getLastStorageVarnode

    public Varnode getLastStorageVarnode()
    Description copied from interface: `Variable`
    Get the last storage varnode for this variable
    Specified by:
      `getLastStorageVarnode` in interface `Variable`
    Returns:
      the last storage varnode associated with this variable
    See Also:
      - `Variable.getVariableStorage()`

  - ### isStackVariable

    public boolean isStackVariable()
    Specified by:
      `isStackVariable` in interface `Variable`
    Returns:
      true if this is a simple variable consisting of a single stack varnode which will be returned by either the `Variable.getFirstStorageVarnode()` or `Variable.getLastStorageVarnode()` methods. The stack offset can be obtained using:

                          getFirstStorageVarnode().getOffset()

  - ### hasStackStorage

    public boolean hasStackStorage()
    Specified by:
      `hasStackStorage` in interface `Variable`
    Returns:
      true if this variable uses simple or compound storage which contains a stack element. If true, the last storage varnode will always be the stack element.
    See Also:
      - `Variable.getLastStorageVarnode()`

  - ### isRegisterVariable

    public boolean isRegisterVariable()
    Specified by:
      `isRegisterVariable` in interface `Variable`
    Returns:
      true if this is a simple variable consisting of a single register varnode which will be returned by either the `Variable.getFirstStorageVarnode()` or `Variable.getLastStorageVarnode()` methods. The register can be obtained using the `Variable.getRegister()` method.

  - ### getRegister

    public Register getRegister()
    Specified by:
      `getRegister` in interface `Variable`
    Returns:
      first storage register associated with this variable, else null is returned. A variable with compound storage may have more than one register or other storage in addition to the register returned by this method.
    See Also:
      - `Variable.isRegisterVariable()`

  - ### getRegisters

    public List<Register> getRegisters()
    Specified by:
      `getRegisters` in interface `Variable`
    Returns:
      all storage register(s) associated with this variable, else null is returned if no registers are used. A variable with compound storage may have more than one register or other storage in addition to the register(s) returned by this method.
    See Also:
      - `Variable.isRegisterVariable()`
      - `Variable.isCompoundVariable()`

  - ### getMinAddress

    public Address getMinAddress()
    Specified by:
      `getMinAddress` in interface `Variable`
    Returns:
      the minimum address corresponding to the first varnode of this storage or null if this is a special empty storage: `VariableStorage.BAD_STORAGE`, `VariableStorage.UNASSIGNED_STORAGE`, `VariableStorage.VOID_STORAGE`

  - ### getStackOffset

    public int getStackOffset()
    Specified by:
      `getStackOffset` in interface `Variable`
    Returns:
      the stack offset associated with simple stack variable (i.e., `Variable.isStackVariable()` returns true).

  - ### isMemoryVariable

    public boolean isMemoryVariable()
    Specified by:
      `isMemoryVariable` in interface `Variable`
    Returns:
      true if this is a simple variable consisting of a single storage memory element which will be returned by either the `Variable.getFirstStorageVarnode()` or `Variable.getVariableStorage()` methods.

  - ### isUniqueVariable

    public boolean isUniqueVariable()
    Specified by:
      `isUniqueVariable` in interface `Variable`
    Returns:
      true if this is a simple variable consisting of a single storage unique/hash element which will be returned by either the `Variable.getFirstStorageVarnode()` or `Variable.getVariableStorage()` methods. The unique hash can be obtained from the storage address offset corresponding to the single storage element.

  - ### isCompoundVariable

    public boolean isCompoundVariable()
    Specified by:
      `isCompoundVariable` in interface `Variable`
    Returns:
      true if this variable uses compound storage consisting of two or more storage elements which will be returned by the `Variable.getVariableStorage()` method. Compound variables will always use a register(s) optionally followed by other storage (i.e., stack).

  - ### hashCode

    public int hashCode()
    Overrides:
      `hashCode` in class `Object`

  - ### equals

    public boolean equals(Object obj)
    Overrides:
      `equals` in class `Object`

  - ### compareTo

    public int compareTo(Variable otherVar)
    Specified by:
      `compareTo` in interface `Comparable<Variable>`

  - ### isEquivalent

    public boolean isEquivalent(Variable otherVar)
    Description copied from interface: `Variable`
    Determine is another variable is equivalent to this variable.
    Specified by:
      `isEquivalent` in interface `Variable`
    Parameters:
      `otherVar` - other variable
    Returns:
      true if the specified variable is equivalent to this variable